#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <wiringPi.h>
#include <wiringPiSPI.h>

#define CS_MCP3208	8			//GPIO 8
#define SPI_CHANNEL	0			//SPI Channel
#define SPI_SPEED	1000000		//spi speed

#define MAX_BUFFER 30

unsigned int gunSensorValue;

int ReadMcp3208ADC(unsigned char adcChannel)
{
	unsigned char buff[3];
	int nAdcValue = 0;

	digitalWrite(CS_MCP3208,0);		//low cs Active
	
	wiringPiSPIDataRW(SPI_CHANNEL, buff, 3);
	
	//8bit data
	buff[1] = 0x0F & buff[1];
	nAdcValue = (buff[1]<<8) | buff[2];
	
	//spi chip Select command
	digitalWrite(CS_MCP3208, 1);
	
	return nAdcValue;
}

int main(void)
{
	int nAdcChannel = 0;
	int nAdcValue = 0;
	int nServerSockfd, nClientSockfd;
	int nClientLen, n;
	char buff[3];
			
	buff[0] = 0x06 | ((nAdcChannel & 0x07) >> 2);
	buff[1] = ((nAdcChannel & 0x07)<<6);
	buff[2] = 0x00;
		
		
	if(wiringPiSetupGpio() == -1)
	{
		fprintf(stdout,"Not start wiringPi: %s\n",strerror(errno));
		return 1;
	}
	
	//wiringpi init
	if(wiringPiSPISetup(SPI_CHANNEL, SPI_SPEED) == -1)
	{
		fprintf(stdout, "wiringPiSPISetup Failed: %s\n", strerror(errno));
		return 1;
	}
	
	pinMode(CS_MCP3208, OUTPUT);
	

	while(1)
	{


		nAdcValue = ReadMcp3208ADC(nAdcChannel);		//sensorRead
		printf("Soil Moisture Sensor Value = %d \n", nAdcValue);
		delay(1000);
		
	}	
	return 0;
}
